This page shows how to display and edit annotations on FlexChart.
Following operations of editing annotations are supported in this sample.
loading...import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as core from '@mescius/wijmo';
import * as chart from '@mescius/wijmo.chart';
import * as annotation from '@mescius/wijmo.chart.annotation';
import { getData } from './data';
import { EditableAnnotationLayer, Button } from './EditableAnnotationLayer';
import { AxisScrollbar } from './AxisScrollbar';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
// create the chart
let al;
let chkbox = document.querySelector('#checkboxIsEditable');
chkbox.addEventListener('change', () => {
al.isEditable = chkbox.checked;
});
let theChart = new chart.FlexChart('#theChart', {
bindingX: 'x',
chartType: 'Scatter',
itemsSource: getData(),
tooltip: {
content: ''
},
series: [
{
name: 'Data',
binding: 'y'
}
],
rendered: () => {
if (!al) {
al = new EditableAnnotationLayer(theChart);
al.isEditable = chkbox.checked;
//add customize button
var triangle, triangleBtn = new Button(function (engine) {
var triangleIcon = new annotation.Polygon({
tooltip: 'Custom Button - Triangle </br>Select to add Triangle Annotation.',
points: [{
x: 10, y: 5
}, {
x: 5, y: 15
}, {
x: 15, y: 15
}],
style: {
fill: 'yellow'
}
});
triangleIcon.render(engine);
return triangleIcon._element;
}, function (point, isDataCoordinate) {
var x = isDataCoordinate ? point.dx : point.x, y = isDataCoordinate ? point.dy : point.y;
triangle = new annotation.Polygon({
attachment: isDataCoordinate ? annotation.AnnotationAttachment.DataCoordinate : annotation.AnnotationAttachment.Absolute,
tooltip: 'Customize Annotation - Triangle',
points: [{
x: x, y: y
}, {
x: x, y: y
}, {
x: x, y: y
}],
style: {
fill: 'yellow'
}
});
al.items.push(triangle);
}, function (originPoint, currentPoint, isDataCoordinate) {
var ox = isDataCoordinate ? originPoint.dx : originPoint.x, oy = isDataCoordinate ? originPoint.dy : originPoint.y, cx = isDataCoordinate ? currentPoint.dx : currentPoint.x, cy = isDataCoordinate ? currentPoint.dy : currentPoint.y, offsetX = Math.abs(cx - ox), offsetY = cy - oy, isXDate = core.isDate(ox), isYDate = core.isDate(oy), oaDate = chart.FlexChart._fromOADate;
triangle.points.clear();
triangle.points.push({ x: ox, y: isYDate ? oaDate(oy - offsetY) : oy - offsetY });
triangle.points.push({ x: isXDate ? oaDate(ox - offsetX) : ox - offsetX, y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY });
triangle.points.push({ x: isXDate ? oaDate(ox - 0 + offsetX) : ox + offsetX, y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY });
});
al.buttons.push(triangleBtn);
//add pre-defined annotations.
var watermarker = new annotation.Text({
position: annotation.AnnotationPosition.Left | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
text: 'watermarker',
tooltip: 'Text Watermarker',
point: { x: 1, y: 1 },
style: { 'fill': '#cccccc', 'font-size': '30px', opacity: 0.2 }
});
al.items.push(watermarker);
var imgmarker = new annotation.Image({
position: annotation.AnnotationPosition.Right | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
tooltip: 'Image Watermarker',
point: { x: 0, y: 1 },
width: 128,
height: 33,
href: 'resources/wijmo-logo-text.png',
style: { opacity: 0.2 }
});
al.items.push(imgmarker);
var centerHLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.DataCoordinate,
position: annotation.AnnotationPosition.Center,
content: 'Vertical Center Line',
start: { x: 50, y: 0 },
end: { x: 50, y: 1000 },
style: {
'stroke-width': '2px',
stroke: 'green'
}
});
al.items.push(centerHLine);
var centerVLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.Relative,
position: annotation.AnnotationPosition.Center,
content: 'Horizontal Center Line',
start: { x: 0, y: 0.5 },
end: { x: 1, y: 0.5 },
style: {
'stroke-width': '2px',
stroke: 'red'
}
});
al.items.push(centerVLine);
var topRange = new annotation.Polygon({
attachment: annotation.AnnotationAttachment.Relative,
points: [{ x: 0, y: 0 }, { x: 0, y: 0.2 }, { x: 1, y: 0.2 }, { x: 1, y: 0 }],
content: 'Top Range',
style: { fill: '#FEF0DB', opacity: 0.5, stroke: '#FEF0DB' }
});
al.items.push(topRange);
//flag
var pointIndex = 10;
['black', 'blue', 'green', 'red', 'yellow'].forEach(function (v) {
var flagSrc = 'resources/flag-' + v + '-icon.png';
var flag = new annotation.Image({
attachment: annotation.AnnotationAttachment.DataIndex,
seriesIndex: 0,
pointIndex: pointIndex,
width: 24,
height: 24,
href: flagSrc
});
al.items.push(flag);
pointIndex += 10;
});
var rect = new annotation.Rectangle({
attachment: annotation.AnnotationAttachment.DataCoordinate,
point: { x: 10, y: 650 },
width: 120,
height: 150,
style: {
'stroke-dasharray': '4 4',
stroke: 'red'
}
});
al.items.push(rect);
var circle = new annotation.Circle({
seriesIndex: 0,
attachment: annotation.AnnotationAttachment.DataCoordinate,
radius: 80,
point: { x: 70, y: 350 },
style: {
stroke: 'blue',
fill: 'blue',
opacity: 0.3
}
});
al.items.push(circle);
}
}
});
let axisScrollBar = new AxisScrollbar(theChart.axes[0]);
window.setTimeout(function () {
axisScrollBar.maxPos = 0.5;
}, 20);
}
Submit and view feedback for

<template>
<div class="container-fluid">
<div class="form-group">
<label id="labelIsEditable" for="checkboxIsEditable">Is Editable:</label>
<input type="checkbox" id="checkboxIsEditable" v-model="isEditable" v-on:change="editableChange" />
<wj-flex-chart bindingX="x" chartType="Scatter" :itemsSource="data" tooltipContent=""
:rendered="chartRendered" :initialized="chartInitialized">
<wj-flex-chart-series name="Data" binding="y"></wj-flex-chart-series>
</wj-flex-chart>
</div>
</div>
</template>
<script setup>
import { getData } from "./data";
import { EditableAnnotationLayer, Button } from "./EditableAnnotationLayer";
import { AxisScrollbar } from "./AxisScrollbar";
import * as core from "@mescius/wijmo";
import * as wjChart from "@mescius/wijmo.chart";
import * as annotation from "@mescius/wijmo.chart.annotation";
import { ref } from "vue";
const data = ref(getData());
const isEditable = ref(true);
const annotationLayer = ref(null);
const theChart = ref(null);
function editableChange() {
if (annotationLayer.value) {
annotationLayer.value.isEditable = isEditable.value;
}
}
function chartInitialized(flex) {
theChart.value = flex;
let axisScrollBar = new AxisScrollbar(theChart.value.axes[0]);
window.setTimeout(function () {
axisScrollBar.maxPos = 0.5;
}, 20);
}
function chartRendered() {
let al = annotationLayer.value;
if (!al) {
al = new EditableAnnotationLayer(theChart.value);
annotationLayer.value = al;
al.isEditable = isEditable.value;
//add customize button
var triangle,
triangleBtn = new Button(
function (engine) {
var triangleIcon = new annotation.Polygon({
tooltip: "Custom Button - Triangle </br>Select to add Triangle Annotation.",
points: [
{
x: 10,
y: 5,
},
{
x: 5,
y: 15,
},
{
x: 15,
y: 15,
},
],
style: {
fill: "yellow",
},
});
triangleIcon.render(engine);
return triangleIcon._element;
},
function (point, isDataCoordinate) {
var x = isDataCoordinate ? point.dx : point.x,
y = isDataCoordinate ? point.dy : point.y;
triangle = new annotation.Polygon({
attachment: isDataCoordinate ? annotation.AnnotationAttachment.DataCoordinate : annotation.AnnotationAttachment.Absolute,
tooltip: "Customize Annotation - Triangle",
points: [
{
x: x,
y: y,
},
{
x: x,
y: y,
},
{
x: x,
y: y,
},
],
style: {
fill: "yellow",
},
});
al.items.push(triangle);
},
function (originPoint, currentPoint, isDataCoordinate) {
var ox = isDataCoordinate ? originPoint.dx : originPoint.x,
oy = isDataCoordinate ? originPoint.dy : originPoint.y,
cx = isDataCoordinate ? currentPoint.dx : currentPoint.x,
cy = isDataCoordinate ? currentPoint.dy : currentPoint.y,
offsetX = Math.abs(cx - ox),
offsetY = cy - oy,
isXDate = core.isDate(ox),
isYDate = core.isDate(oy),
oaDate = wjChart.FlexChart._fromOADate;
triangle.points.clear();
triangle.points.push({ x: ox, y: isYDate ? oaDate(oy - offsetY) : oy - offsetY });
triangle.points.push({ x: isXDate ? oaDate(ox - offsetX) : ox - offsetX, y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY });
triangle.points.push({ x: isXDate ? oaDate(ox - 0 + offsetX) : ox + offsetX, y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY });
},
);
al.buttons.push(triangleBtn);
//add pre-defined annotations.
var watermarker = new annotation.Text({
position: annotation.AnnotationPosition.Left | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
text: "watermarker",
tooltip: "Text Watermarker",
point: { x: 1, y: 1 },
style: { fill: "#cccccc", "font-size": "30px", opacity: 0.2 },
});
al.items.push(watermarker);
var imgmarker = new annotation.Image({
position: annotation.AnnotationPosition.Right | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
tooltip: "Image Watermarker",
point: { x: 0, y: 1 },
width: 128,
height: 33,
href: "resources/wijmo-logo-text.png",
style: { opacity: 0.2 },
});
al.items.push(imgmarker);
var centerHLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.DataCoordinate,
position: annotation.AnnotationPosition.Center,
content: "Vertical Center Line",
start: { x: 50, y: 0 },
end: { x: 50, y: 1000 },
style: {
"stroke-width": "2px",
stroke: "green",
},
});
al.items.push(centerHLine);
var centerVLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.Relative,
position: annotation.AnnotationPosition.Center,
content: "Horizontal Center Line",
start: { x: 0, y: 0.5 },
end: { x: 1, y: 0.5 },
style: {
"stroke-width": "2px",
stroke: "red",
},
});
al.items.push(centerVLine);
var topRange = new annotation.Polygon({
attachment: annotation.AnnotationAttachment.Relative,
points: [
{ x: 0, y: 0 },
{ x: 0, y: 0.2 },
{ x: 1, y: 0.2 },
{ x: 1, y: 0 },
],
content: "Top Range",
style: { fill: "#FEF0DB", opacity: 0.5, stroke: "#FEF0DB" },
});
al.items.push(topRange);
//flag
var pointIndex = 10;
["black", "blue", "green", "red", "yellow"].forEach(function (v) {
var flagSrc = "resources/flag-" + v + "-icon.png";
var flag = new annotation.Image({
attachment: annotation.AnnotationAttachment.DataIndex,
seriesIndex: 0,
pointIndex: pointIndex,
width: 24,
height: 24,
href: flagSrc,
});
al.items.push(flag);
pointIndex += 10;
});
var rect = new annotation.Rectangle({
attachment: annotation.AnnotationAttachment.DataCoordinate,
point: { x: 10, y: 650 },
width: 120,
height: 150,
style: {
"stroke-dasharray": "4 4",
stroke: "red",
},
});
al.items.push(rect);
var circle = new annotation.Circle({
seriesIndex: 0,
attachment: annotation.AnnotationAttachment.DataCoordinate,
radius: 80,
point: { x: 70, y: 350 },
style: {
stroke: "blue",
fill: "blue",
opacity: 0.3,
},
});
al.items.push(circle);
}
}
</script>
<style>
.wj-flexchart {
margin: 10px 0;
}
body {
margin-bottom: 24pt;
}
.wj-flexchart .wjanno-editable-layer .wjanno-container {
fill: #eee;
stroke: #666;
stroke-width: 1;
}
.wj-flexchart .wjanno-editable-layer .wjanno-dc-icon .wjanno-container {
fill: #eee;
}
.wj-flexchart .wjanno-editable-layer .wjanno-icon-selected .wjanno-container {
fill: #89E;
}
.no-selection {
user-select: none;
-webkit-user-select: none;
-moz-user-select: none;
-ms-user-select: none;
-o-user-select: none;
}
.wj-flexchart {
padding-bottom: 25px;
}
/**** Axis Scrollbar Css *****/
.wj-flexchart .wj-axis-scrollbar-container {
position: relative;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-rangeslider {
border: 1px solid #EAEAEA;
background-color: #EAEAEA;
border-bottom-left-radius: 6px;
border-bottom-right-radius: 6px;
border-top-left-radius: 6px;
border-top-right-radius: 6px;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-hrangeslider {
height: 20px;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-vrangeslider {
width: 20px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Editable Annotations</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getData() {
var data = [],
numCount = 100;
for (var i = 0; i < numCount; i++) {
data.push({
x: getRandomValue(100),
y: getRandomValue(1000)
});
}
return data;
}
//
function getRandomValue(max) {
return Math.round(Math.random() * max);
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjChart from '@mescius/wijmo.chart';
import * as Core from '@mescius/wijmo';
import * as Chart from '@mescius/wijmo.react.chart';
import * as annotation from '@mescius/wijmo.chart.annotation';
import './app.css';
import { data } from './data';
import { EditableAnnotationLayer, Button } from './EditableAnnotationLayer';
import { AxisScrollbar } from './AxisScrollbar';
function App() {
const [isEditable, setIsEditable] = useState(true);
const [init, setInit] = useState(false);
const theChartRef = useRef(null);
const alRef = useRef(null);
const editableChange = useEvent(() => {
if (alRef.current) {
alRef.current.isEditable = !isEditable;
setIsEditable(!isEditable);
}
});
const chartInitialized = useEvent((flex) => {
theChartRef.current = flex;
let axisScrollBar = new AxisScrollbar(theChartRef.current.axes[0]);
window.setTimeout(function () {
axisScrollBar.maxPos = 0.5;
}, 20);
setInit(true);
});
const chartRendered = useEvent(() => {
if (init && !alRef.current) {
alRef.current = new EditableAnnotationLayer(theChartRef.current);
const al = alRef.current;
al.isEditable = isEditable;
//
//add customize button
var triangle, triangleBtn = new Button(function (engine) {
var triangleIcon = new annotation.Polygon({
tooltip: 'Custom Button - Triangle </br>Select to add Triangle Annotation.',
points: [{
x: 10, y: 5
}, {
x: 5, y: 15
}, {
x: 15, y: 15
}],
style: {
fill: 'yellow'
}
});
triangleIcon.render(engine);
return triangleIcon._element;
}, function (point, isDataCoordinate) {
var x = isDataCoordinate ? point.dx : point.x, y = isDataCoordinate ? point.dy : point.y;
triangle = new annotation.Polygon({
attachment: isDataCoordinate ? annotation.AnnotationAttachment.DataCoordinate : annotation.AnnotationAttachment.Absolute,
tooltip: 'Customize Annotation - Triangle',
points: [{
x: x, y: y
}, {
x: x, y: y
}, {
x: x, y: y
}],
style: {
fill: 'yellow'
}
});
al.items.push(triangle);
}, function (originPoint, currentPoint, isDataCoordinate) {
var ox = isDataCoordinate ? originPoint.dx : originPoint.x, oy = isDataCoordinate ? originPoint.dy : originPoint.y, cx = isDataCoordinate ? currentPoint.dx : currentPoint.x, cy = isDataCoordinate ? currentPoint.dy : currentPoint.y, offsetX = Math.abs(cx - ox), offsetY = cy - oy, isXDate = Core.isDate(ox), isYDate = Core.isDate(oy), oaDate = wjChart.FlexChart._fromOADate;
triangle.points.clear();
triangle.points.push({ x: ox, y: isYDate ? oaDate(oy - offsetY) : oy - offsetY });
triangle.points.push({ x: isXDate ? oaDate(ox - offsetX) : ox - offsetX, y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY });
triangle.points.push({ x: isXDate ? oaDate(ox - 0 + offsetX) : ox + offsetX, y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY });
});
al.buttons.push(triangleBtn);
//add pre-defined annotations.
var watermarker = new annotation.Text({
position: annotation.AnnotationPosition.Left | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
text: 'watermarker',
tooltip: 'Text Watermarker',
point: { x: 1, y: 1 },
style: { 'fill': '#cccccc', 'font-size': '30px', opacity: 0.2 }
});
al.items.push(watermarker);
var imgmarker = new annotation.Image({
position: annotation.AnnotationPosition.Right | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
tooltip: 'Image Watermarker',
point: { x: 0, y: 1 },
width: 128,
height: 33,
href: 'resources/wijmo-logo-text.png',
style: { opacity: 0.2 }
});
al.items.push(imgmarker);
var centerHLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.DataCoordinate,
position: annotation.AnnotationPosition.Center,
content: 'Vertical Center Line',
start: { x: 50, y: 0 },
end: { x: 50, y: 1000 },
style: {
'stroke-width': '2px',
stroke: 'green'
}
});
al.items.push(centerHLine);
var centerVLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.Relative,
position: annotation.AnnotationPosition.Center,
content: 'Horizontal Center Line',
start: { x: 0, y: 0.5 },
end: { x: 1, y: 0.5 },
style: {
'stroke-width': '2px',
stroke: 'red'
}
});
al.items.push(centerVLine);
var topRange = new annotation.Polygon({
attachment: annotation.AnnotationAttachment.Relative,
points: [{ x: 0, y: 0 }, { x: 0, y: 0.2 }, { x: 1, y: 0.2 }, { x: 1, y: 0 }],
content: 'Top Range',
style: { fill: '#FEF0DB', opacity: 0.5, stroke: '#FEF0DB' }
});
al.items.push(topRange);
//flag
var pointIndex = 10;
['black', 'blue', 'green', 'red', 'yellow'].forEach(function (v) {
var flagSrc = 'resources/flag-' + v + '-icon.png';
var flag = new annotation.Image({
attachment: annotation.AnnotationAttachment.DataIndex,
seriesIndex: 0,
pointIndex: pointIndex,
width: 24,
height: 24,
href: flagSrc
});
al.items.push(flag);
pointIndex += 10;
});
var rect = new annotation.Rectangle({
attachment: annotation.AnnotationAttachment.DataCoordinate,
point: { x: 10, y: 650 },
width: 120,
height: 150,
style: {
'stroke-dasharray': '4 4',
stroke: 'red'
}
});
al.items.push(rect);
var circle = new annotation.Circle({
seriesIndex: 0,
attachment: annotation.AnnotationAttachment.DataCoordinate,
radius: 80,
point: { x: 70, y: 350 },
style: {
stroke: 'blue',
fill: 'blue',
opacity: 0.3
}
});
al.items.push(circle);
}
});
return (<div className="container-fluid">
<div className="form-group">
<label id="labelIsEditable">Is Editable:
<input type="checkbox" id="checkboxIsEditable" checked={isEditable} onChange={editableChange}/>
</label>
<Chart.FlexChart initialized={chartInitialized} itemsSource={data} tooltipContent="" rendered={chartRendered} chartType="Scatter" bindingX="x">
<Chart.FlexChartSeries name="data" binding="y"/>
</Chart.FlexChart>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexChart Editable Annotations</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexchart {
margin: 10px 0;
}
.wj-flexchart .wjanno-editable-layer .wjanno-container {
fill: #eee;
stroke: #666;
stroke-width: 1;
}
.wj-flexchart .wjanno-editable-layer .wjanno-dc-icon .wjanno-container {
fill: #eee;
}
.wj-flexchart .wjanno-editable-layer .wjanno-icon-selected .wjanno-container {
fill: #89E;
}
.no-selection {
user-select: none;
-webkit-user-select: none;
-moz-user-select: none;
-ms-user-select: none;
-o-user-select: none;
}
.wj-flexchart {
padding-bottom: 25px;
}
/**** Axis Scrollbar Css *****/
.wj-flexchart .wj-axis-scrollbar-container {
position: relative;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-rangeslider {
border: 1px solid #EAEAEA;
background-color: #EAEAEA;
border-bottom-left-radius: 6px;
border-bottom-right-radius: 6px;
border-top-left-radius: 6px;
border-top-right-radius: 6px;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-hrangeslider {
height: 20px;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-vrangeslider {
width: 20px;
}
function getData() {
var data = [], numCount = 100;
for (var i = 0; i < numCount; i++) {
data.push({
x: getRandomValue(100),
y: getRandomValue(1000)
});
}
return data;
}
function getRandomValue(max) {
return Math.round(Math.random() * max);
}
export const data = getData();
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, AfterViewInit, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
import { DataService } from './app.data';
import { EditableAnnotationLayer, Button } from './EditableAnnotationLayer';
import { AxisScrollbar } from './AxisScrollbar';
import * as core from '@mescius/wijmo';
import * as wjChart from '@mescius/wijmo.chart';
import * as annotation from '@mescius/wijmo.chart.annotation';
//
@Component({
standalone: true,
providers: [DataService],
imports: [FormsModule, WjChartModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements AfterViewInit {
data: any[];
isEditable: boolean;
al: EditableAnnotationLayer;
@ViewChild('theChart', { static: true }) theChart: wjChart.FlexChart;
//
constructor(@Inject(DataService) private dataService: DataService) {
this.data = dataService.getData();
this.isEditable = true;
}
//
editableChange() {
if (this.al) {
this.al.isEditable = this.isEditable;
}
}
//
chartRendered() {
let al = this.al;
if (!al) {
al = new EditableAnnotationLayer(this.theChart);
this.al = al;
al.isEditable = this.isEditable;
//add customize button
var triangle: any,
triangleBtn = new Button(
function (engine: wjChart.IRenderEngine) {
var triangleIcon = new annotation.Polygon({
tooltip: 'Custom Button - Triangle </br>Select to add Triangle Annotation.',
points: [
{
x: 10,
y: 5,
},
{
x: 5,
y: 15,
},
{
x: 15,
y: 15,
},
],
style: {
fill: 'yellow',
},
});
triangleIcon.render(engine);
return triangleIcon._element;
},
function (point: any, isDataCoordinate: boolean) {
var x = isDataCoordinate ? point.dx : point.x,
y = isDataCoordinate ? point.dy : point.y;
triangle = new annotation.Polygon({
attachment: isDataCoordinate
? annotation.AnnotationAttachment.DataCoordinate
: annotation.AnnotationAttachment.Absolute,
tooltip: 'Customize Annotation - Triangle',
points: [
{
x: x,
y: y,
},
{
x: x,
y: y,
},
{
x: x,
y: y,
},
],
style: {
fill: 'yellow',
},
});
al.items.push(triangle);
},
function (originPoint: any, currentPoint: any, isDataCoordinate: boolean) {
var ox = isDataCoordinate ? originPoint.dx : originPoint.x,
oy = isDataCoordinate ? originPoint.dy : originPoint.y,
cx = isDataCoordinate ? currentPoint.dx : currentPoint.x,
cy = isDataCoordinate ? currentPoint.dy : currentPoint.y,
offsetX = Math.abs(cx - ox),
offsetY = cy - oy,
isXDate = core.isDate(ox),
isYDate = core.isDate(oy),
oaDate = wjChart.FlexChart._fromOADate;
triangle.points.clear();
triangle.points.push({ x: ox, y: isYDate ? oaDate(oy - offsetY) : oy - offsetY });
triangle.points.push({
x: isXDate ? oaDate(ox - offsetX) : ox - offsetX,
y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY,
});
triangle.points.push({
x: isXDate ? oaDate(ox - 0 + offsetX) : ox + offsetX,
y: isYDate ? oaDate(oy - 0 + offsetY) : oy + offsetY,
});
},
);
al.buttons.push(triangleBtn);
//add pre-defined annotations.
var watermarker = new annotation.Text({
position: annotation.AnnotationPosition.Left | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
text: 'watermarker',
tooltip: 'Text Watermarker',
point: { x: 1, y: 1 },
style: { fill: '#cccccc', 'font-size': '30px', opacity: 0.2 },
});
al.items.push(watermarker);
var imgmarker = new annotation.Image({
position: annotation.AnnotationPosition.Right | annotation.AnnotationPosition.Top,
attachment: annotation.AnnotationAttachment.Relative,
tooltip: 'Image Watermarker',
point: { x: 0, y: 1 },
width: 128,
height: 33,
href: 'resources/wijmo-logo-text.png',
style: { opacity: 0.2 },
});
al.items.push(imgmarker);
var centerHLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.DataCoordinate,
position: annotation.AnnotationPosition.Center,
content: 'Vertical Center Line',
start: { x: 50, y: 0 },
end: { x: 50, y: 1000 },
style: {
'stroke-width': '2px',
stroke: 'green',
},
});
al.items.push(centerHLine);
var centerVLine = new annotation.Line({
attachment: annotation.AnnotationAttachment.Relative,
position: annotation.AnnotationPosition.Center,
content: 'Horizontal Center Line',
start: { x: 0, y: 0.5 },
end: { x: 1, y: 0.5 },
style: {
'stroke-width': '2px',
stroke: 'red',
},
});
al.items.push(centerVLine);
var topRange = new annotation.Polygon({
attachment: annotation.AnnotationAttachment.Relative,
points: [
{ x: 0, y: 0 },
{ x: 0, y: 0.2 },
{ x: 1, y: 0.2 },
{ x: 1, y: 0 },
],
content: 'Top Range',
style: { fill: '#FEF0DB', opacity: 0.5, stroke: '#FEF0DB' },
});
al.items.push(topRange);
//flag
var pointIndex = 10;
['black', 'blue', 'green', 'red', 'yellow'].forEach(function (v) {
var flagSrc = 'resources/flag-' + v + '-icon.png';
var flag = new annotation.Image({
attachment: annotation.AnnotationAttachment.DataIndex,
seriesIndex: 0,
pointIndex: pointIndex,
width: 24,
height: 24,
href: flagSrc,
});
al.items.push(flag);
pointIndex += 10;
});
var rect = new annotation.Rectangle({
attachment: annotation.AnnotationAttachment.DataCoordinate,
point: { x: 10, y: 650 },
width: 120,
height: 150,
style: {
'stroke-dasharray': '4 4',
stroke: 'red',
},
});
al.items.push(rect);
var circle = new annotation.Circle({
seriesIndex: 0,
attachment: annotation.AnnotationAttachment.DataCoordinate,
radius: 80,
point: { x: 70, y: 350 },
style: {
stroke: 'blue',
fill: 'blue',
opacity: 0.3,
},
});
al.items.push(circle);
}
}
//
ngAfterViewInit() {
let axisScrollBar = new AxisScrollbar(this.theChart.axes[0]);
window.setTimeout(function () {
axisScrollBar.maxPos = 0.5;
}, 20);
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Editable Annotations</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div class="form-group">
</div>
<div class="form-group">
<label id="labelIsEditable" for="checkboxIsEditable">Is Editable:</label>
<input type="checkbox" id="checkboxIsEditable" [(ngModel)]="isEditable" (change)="editableChange()" />
<wj-flex-chart #theChart bindingX="x" chartType="Scatter" [itemsSource]="data" tooltipContent="" (rendered)="chartRendered()">
<wj-flex-chart-series name="Data" binding="y"></wj-flex-chart-series>
</wj-flex-chart>
</div>
</div>
import { Injectable } from '@angular/core';
//
@Injectable()
export class DataService {
getData() {
var data = [],
numCount = 100;
for (var i = 0; i < numCount; i++) {
data.push({
x: this.getRandomValue(100),
y: this.getRandomValue(1000)
});
}
return data;
}
//
getRandomValue(max: number) {
return Math.round(Math.random() * max);
}
}
.wj-flexchart {
margin: 10px 0;
}
body {
margin-bottom: 24pt;
}
.wj-flexchart .wjanno-editable-layer .wjanno-container {
fill: #eee;
stroke: #666;
stroke-width: 1;
}
.wj-flexchart .wjanno-editable-layer .wjanno-dc-icon .wjanno-container {
fill: #eee;
}
.wj-flexchart .wjanno-editable-layer .wjanno-icon-selected .wjanno-container {
fill: #89E;
}
.no-selection {
user-select: none;
-webkit-user-select: none;
-moz-user-select: none;
-ms-user-select: none;
-o-user-select: none;
}
.wj-flexchart {
padding-bottom: 25px;
}
/**** Axis Scrollbar Css *****/
.wj-flexchart .wj-axis-scrollbar-container {
position: relative;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-rangeslider {
border: 1px solid #EAEAEA;
background-color: #EAEAEA;
border-bottom-left-radius: 6px;
border-bottom-right-radius: 6px;
border-top-left-radius: 6px;
border-top-right-radius: 6px;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-hrangeslider {
height: 20px;
}
.wj-flexchart .wj-axis-scrollbar-container .wj-chart-vrangeslider {
width: 20px;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);